#region // Copyright (c) 2002-2003, SIL International. All Rights Reserved.   
// <copyright from='2002' to='2003' company='SIL International'>
//		Copyright (c) 2002-2003, SIL International. All Rights Reserved.   
//    
//		Distributable under the terms of either the Common Public License or the
//		GNU Lesser General Public License, as specified in the LICENSING.txt file.
// </copyright> 
#endregion
using System;
using System.IO;
using System.Text;
using System.Xml;
using GBF;

namespace GBF
{
	class XSEMWriter
	{
		protected XmlTextWriter xml;
		protected GBFReader gbf;
		bool InDiv;
		bool InPoetry;
		bool InRed;
		bool IsItalic;
		bool LatentItalic;
		bool InVerse;
		bool InChapter;
		bool InLine;
		bool InLineGroup;
		bool InParagraph;
		bool InPsalmBookDiv;
		bool InPsalmTitleDiv;
		bool headOK;
		int NoteNumber;
		int QuotationLevel;
		string [] QuoteStart;
		const int maxQuoteLevel = 20;
		int ParagraphStarted;

		protected void BalanceQuotes(string s)
		{
			int i;
			int j = 0;


			for(i = 0; i < s.Length; i++)
			{
				if (j >= QuotationLevel)
					ParagraphStarted = 0;
				if (ParagraphStarted == 1)
					ParagraphStarted = 0;
				if (s[i] == '')
				{
					if (ParagraphStarted >= 2)
                    {
						j++;
						if ((j & 1) == 0)
						{
							Console.WriteLine("{0} quote level {1} paragraph reminder opens with ",
								gbf.Reference(), j);
						}
					}
					else
					{
						if (QuotationLevel < maxQuoteLevel)
							QuoteStart[QuotationLevel] = gbf.Reference();
						QuotationLevel++;
						if ((QuotationLevel & 1) == 0)
						{
							Console.WriteLine("{0} quote level {1} opens with ",
								gbf.Reference(), QuotationLevel);
							int k;
							for (k = QuotationLevel - 2; k >= 0; k--)
							{
								if (k < maxQuoteLevel)
                                    Console.WriteLine("    Level {0} started {1}", k+1, QuoteStart[k]);
							}
						}
					}
				}
				else if (s[i] == '')
				{
					if (ParagraphStarted >= 2)
					{
						if (j < QuotationLevel)
						{
							j++;
							if ((j & 1) == 1)
							{
								Console.WriteLine("{0} quote level {1} paragraph reminder opens with ",
									gbf.Reference(), j);
							}
						}
					}
					else
					{
						if (QuotationLevel < maxQuoteLevel)
                            QuoteStart[QuotationLevel] = gbf.Reference();
						QuotationLevel++;
						if ((QuotationLevel & 1) == 1)
						{
							Console.WriteLine("{0} quote level {1} opens with ",
								gbf.Reference(), QuotationLevel);
						}
					}
				}
				else if (s[i] == '')
				{
					if (QuotationLevel < 1)
					{
						Console.WriteLine("{0} unmatched closing quote ", gbf.Reference());
					}
					else
					{
						if ((QuotationLevel & 1) == 0)
						{
							Console.WriteLine("{0} quote level {1} closes with ", gbf.Reference(), QuotationLevel);
						}
						QuotationLevel--;
					}
				}
				else if (s[i] == '')
				{
					if ((s.Length <= (i+1)) || (!Char.IsLetter(s, i+1)))
					{
						if (((i > 0) && (s[i-1] != 's')) || (i == 0) ||
							((i > 3) && (s[i-3] == 'Y') && (s[i-2] == 'e') && (s[i-1] == 's')) ||
							((i > 4) && (s[i-4] == 'e') && (s[i-3] == 'y') && (s[i-2] == 'e') && (s[i-1] == 's')) ||
							((i > 4) && (s[i-4] == 'b') && (s[i-3] == 'e') && (s[i-2] == 'r') && (s[i-1] == 's')) ||
							((i > 4) && (s[i-4] == 'g') && (s[i-3] == 'o') && (s[i-2] == 'd') && (s[i-1] == 's')))
						{
							if (!(((i > 4) && (s[i-4] == 'r') && (s[i-3] == 'i') && (s[i-2] == 'c') && (s[i-1] == 'e')) ||
								((i > 4) && (s[i-4] == 'e') && (s[i-3] == 'n') && (s[i-2] == 'c') && (s[i-1] == 'e')) ||
								((i > 4) && (s[i-4] == 'e') && (s[i-3] == 'l') && (s[i-2] == 'i') && (s[i-1] == 'x'))))
							{
								if (QuotationLevel < 1)
									Console.WriteLine("{0} unmatched closing quote ", gbf.Reference());
								else
								{
									if ((QuotationLevel & 1) == 1)
									{
										Console.WriteLine("{0} quote level {1} closes with ", gbf.Reference(), QuotationLevel);
									}
									QuotationLevel--;
								}
							}
						}
					}
				}
			
			}
			if (ParagraphStarted >= 2)
			{
				if (QuotationLevel != 0)
					Console.WriteLine("{0} missing expected open quote reminders.", gbf.Reference());
				ParagraphStarted = 0;
			}
		}

		protected void StartLine()
		{
			headOK = false;
			if (InPoetry)
			{
				if (InParagraph)
				{
					xml.WriteEndElement();	// p
					InParagraph = false;
				}
				if (!InLineGroup)
				{
					xml.WriteStartElement("lineGroup");
					InLineGroup = true;
				}
				if (!InLine)
				{
					xml.WriteStartElement("line");
					InLine = true;
				}
			}
			else
			{
				if (InLine)
				{
					xml.WriteEndElement();	// line
					InLine = false;
				}
				if (InLineGroup)
				{
					xml.WriteEndElement();	// lineGroup
					InLineGroup = false;
				}
				if (!InParagraph)
				{
					xml.WriteStartElement("p");
					InParagraph = true;
				}
			}
		}

		protected void EndLine()
		{
			if (IsItalic)
			{
				xml.WriteEndElement();
				IsItalic = false;
				LatentItalic = true;
			}
			if (InLine)
			{
				xml.WriteEndElement();	// line
				InLine = false;
			}
			if (InLineGroup)
			{
				xml.WriteEndElement();	// lineGroup
				InLineGroup = false;
			}
			if (InParagraph)
			{
				xml.WriteEndElement();	// p
				InParagraph = false;
			}
		}

		protected void StartItalic()
		{
			StartLine();
			xml.WriteStartElement("supplied");
			IsItalic = true;
			LatentItalic = false;
		}

		protected void EndItalic()
		{
			if (!IsItalic && !LatentItalic)
			{
				Console.WriteLine("Redundant <Fi> at {0}", gbf.Reference());
			}
			LatentItalic = false;
			if (IsItalic)
			{
				xml.WriteEndElement();	// supplied
				IsItalic = false;
			}
		}


		protected string ReadBook(string StartToken)
		{
			int i;
			string s;
			bool startOfVerse = false;
			int verseBridgeStart = 0;
			int verseBridgeEnd = 0;
			string NoteStartAnchor = "";
			NoteNumber = 0;
			
			headOK = false;
			s = StartToken;
			while (!s.StartsWith("<SB") && !gbf.Eof())
			{
				Console.WriteLine("SKIPPED AT {0}: {1}", gbf.Reference(), s);
				s = gbf.GetToken();
				if (s == "<ZZ>")
					return s;
			}
			xml.WriteStartElement("book");
			xml.WriteAttributeString("value", gbf.bookValue);
			s = gbf.GetToken();	// Expecting <TT> or <TN>
			if (s == "<TN>")
			{
				do
				{
					s = gbf.GetToken();
					if (s.StartsWith("<") && (s != "<Tn>"))
						Console.WriteLine("UNEXPECTED TOKEN IN SHORT TITLE AT {0}: {1}", gbf.Reference(), s);
				} while ((s != "<Tn>") && !gbf.Eof());
				s = gbf.GetToken();	// Expecting <TT>
			}
			if (s == "<TT>")
			{
				xml.WriteStartElement("title");
				do
				{
					s = gbf.GetToken();
					if (!s.StartsWith("<"))
						xml.WriteString(s);
					else if (s == "<CM>")
						xml.WriteString(" ");
					else if (s != "<Tt>")
						Console.WriteLine("UNEXPECTED TOKEN IN TITLE AT {0}: {1}", gbf.Reference(), s);
				} while ((s != "<Tt>") && !gbf.Eof());
				xml.WriteEndElement();	// title
			}
			xml.WriteStartElement("text");
			Console.Write("Reading {0}\r", gbf.bookValue);
			s = gbf.GetToken();
			while ((!gbf.Eof()) && (!s.StartsWith("<SB")) && (s != "<ZZ>")
				&& (s != "<BA>") && (s != "<BN>"))
			{
				if (startOfVerse && !s.StartsWith("<SV"))
				{
					NoteNumber = 0;
					StartLine();
					if (InVerse)
					{
						xml.WriteElementString("verseEnd","");
						InVerse = false;
					}
					xml.WriteStartElement("verse");
					xml.WriteAttributeString("value", verseBridgeStart.ToString());
					if (verseBridgeEnd > 0)
					{
						xml.WriteAttributeString("valueEnd", verseBridgeEnd.ToString());
					}
					xml.WriteEndElement();	// verse
					InVerse = true;
					verseBridgeStart = verseBridgeEnd = 0;
					startOfVerse = false;
				}
				if (IsItalic && s.StartsWith("<") && (s != "<Fi>") && (!s.StartsWith("<WT")))
				{
					xml.WriteEndElement();	// supplied
					IsItalic = false;
					LatentItalic = true;
				}
				if (s.StartsWith("<SC"))
				{
					if (InVerse)
					{
						xml.WriteElementString("verseEnd","");
						InVerse = false;
					}
					if (InChapter)
					{
						xml.WriteElementString("chapterEnd","");
						InChapter = false;
					}
			
					if (InPsalmTitleDiv)
					{
						EndLine();
						xml.WriteEndElement();	// div
						InPsalmTitleDiv = false;
					}
					if (gbf.iBook == 19)
					{
						InPsalmTitleDiv = true;
						xml.WriteStartElement("div");
						xml.WriteAttributeString("type", "psalm");
					}
					else
					{
						if (!InDiv)
						{
							InDiv = true;
							xml.WriteStartElement("div");
							headOK = true;
						}
					}
					xml.WriteStartElement("chapter");
					xml.WriteAttributeString("value", gbf.iChapter.ToString());
					xml.WriteEndElement();	// chapter
					InChapter = true;
				}
				else if (s.StartsWith("<SV"))
				{
					if (verseBridgeStart == 0)
						verseBridgeStart = gbf.iVerse;
					else
						verseBridgeEnd = gbf.iVerse;
					startOfVerse = true;
				}
				else if (!s.StartsWith("<"))
				{
					StartLine();
					if (LatentItalic)
					{
						StartItalic();
					}
					xml.WriteString(s);
					BalanceQuotes(s);
				}
				else if (s == "<CM>")
				{
					EndLine();
					StartLine();
					if (InPoetry)
						ParagraphStarted++;
					else
						ParagraphStarted = 2;
				}
				else if (s == "<CL>")
				{
					if (InLine)
					{
						xml.WriteEndElement();	// line
						InLine = false;
					}
					if (InParagraph)
					{
						xml.WriteEndElement();	// p
						InParagraph = false;
					}
					StartLine();
					if (!InPoetry)
						ParagraphStarted++;
				}
				else if (s == "<RB>")
				{
					if (NoteStartAnchor != "")
						Console.WriteLine("<RB> without <RF> before {0}", gbf.Reference());
					xml.WriteStartElement("anchor");
					NoteStartAnchor = "n"+gbf.Anchor();
					if (NoteNumber > 0)
						NoteStartAnchor += "."+NoteNumber.ToString();
					NoteNumber++;
					xml.WriteAttributeString("id", NoteStartAnchor);
					xml.WriteEndElement();	// anchor
				}
				else if (s == "<RF>")
				{
					xml.WriteStartElement("note");
					xml.WriteAttributeString("type", "translation");
					if (NoteStartAnchor != "")
					{
						xml.WriteAttributeString("target", NoteStartAnchor);
						NoteStartAnchor = "";
					}
					do
					{
						s = gbf.GetToken();
						if (s.StartsWith("<"))
						{
							if (s != "<Rf>")
								Console.WriteLine("Unexpected token {0} at {1}", s, gbf.Reference());
						}
						else
						{
							xml.WriteString(s);
						}
					} while (!gbf.Eof() && (s != "<Rf>"));
					xml.WriteEndElement();	// note
				}
				else if (s == "<FR>")
				{
					if (InRed)
					{
						Console.WriteLine("Redundant <FR> at {0}", gbf.Reference());
					}
					else
					{
						InRed = true;
						xml.WriteStartElement("q");
						xml.WriteAttributeString("who","Jesus");
						xml.WriteEndElement();	// q
					}
				}
				else if (s == "<Fr>")
				{
					if (!InRed)
					{
						Console.WriteLine("Redundant <Fr> at {0}", gbf.Reference());
					}
					else
					{
						xml.WriteElementString("qEnd","");
						InRed = false;
					}
				}
				else if (s == "<FI>")
				{
					StartItalic();
				}
				else if (s == "<Fi>")
				{
					EndItalic();
				}
				else if (s == "<PP>")
				{
					if (InPoetry)
					{
						Console.WriteLine("Redundant <PP> at {0}", gbf.Reference());
					}
					InPoetry = true;
				}
				else if (s == "<Pp>")
				{
					if (!InPoetry)
					{
						Console.WriteLine("Redundant <Pp> at {0}", gbf.Reference());
					}
					InPoetry = false;
				}
				else if (s == "<BP>")
				{
					do
					{
						s = gbf.GetToken();
						if (!s.StartsWith("<"))
						{
							StartLine();
							xml.WriteString(s);
						}
						else if (s == "<CM>")
						{
							EndLine();
						}
						else if (!s.StartsWith("<B"))
						{
							Console.WriteLine("{0} unhandled at {1}", s, gbf.Reference());
						}
					} while ((!gbf.Eof()) && (!s.StartsWith("<B")));
					if (InDiv)
					{
						xml.WriteEndElement();
						InDiv = false;
					}
				}
				else if (s == "<TH>")
				{
					EndLine();
					StartLine();
				}
				else if (s == "<Th>")
				{
					EndLine();
				}
				else if (s == "<TS>")
				{
					EndLine();
					if (InDiv)
					{
						if (!headOK)
						{
							xml.WriteEndElement();	// div
							xml.WriteStartElement("div");
						}
					}
					else
					{
						xml.WriteStartElement("div");
						InDiv = true;
					}
					xml.WriteStartElement("head");
					do
					{
						s = gbf.GetToken();
						if (!s.StartsWith("<"))
							xml.WriteString(s);
						else if (s == "<CM>")
							xml.WriteString(" ");
						else if (s != "<Ts>")
							Console.WriteLine("Unhandled token {0} at {1}", s, gbf.Reference());
					} while (!gbf.Eof() && (s != "<Ts>"));
					xml.WriteEndElement();	// head
					headOK = false;
				}
				else if (s == "<TB>")
				{
					if (InVerse)
					{
						xml.WriteElementString("verseEnd","");
						InVerse = false;
					}
					if (InChapter)
					{
						xml.WriteElementString("chapterEnd","");
						InChapter = false;
					}
					EndLine();

					if (InPsalmTitleDiv)
					{
						xml.WriteEndElement();	// div
						InPsalmTitleDiv = false;
					}
					if (InPsalmBookDiv)
					{
						xml.WriteEndElement();	// div
						InPsalmBookDiv = false;
					}
					xml.WriteStartElement("div");
					xml.WriteAttributeString("type", "book");
					InPsalmBookDiv = true;
					xml.WriteStartElement("head");
					do
					{
						s = gbf.GetToken();
						if (!s.StartsWith("<"))
							xml.WriteString(s);
						else if (s == "<CM>")
							xml.WriteString(" ");
						else if (s != "<Tb>")
							Console.WriteLine("Unhandled tag {0} at {1}", s, gbf.Reference());
					} while (!gbf.Eof() && (s != "<Tb>"));
					xml.WriteEndElement();	// head
				}
				else if (s == "<TC>")
				{
					do	// Skip comment contents
					{
						s = gbf.GetToken();
					} while (!gbf.Eof() && (s != "<Tc>"));
				}
				else if (s == "<TP>")
				{
					StartLine();
					headOK = false;
				}
				else if (s == "<Tp>")
				{
					EndLine();
					if (InDiv)
					{
						xml.WriteEndElement();	// div
					}
					xml.WriteStartElement("div");
					InDiv = true;
					headOK = true;
				}
				s = gbf.GetToken();
			}


			if (InRed)
			{
				Console.WriteLine("Warning: dangling red at {0}", gbf.Reference());
				xml.WriteElementString("qEnd","");
				InRed = false;
			}
			if (IsItalic)
			{
				Console.WriteLine("Warning: dangling italic at {0}", gbf.Reference());
				EndItalic();
			}
			if (InVerse)
			{
				xml.WriteElementString("verseEnd","");
				InVerse = false;
			}
			if (InChapter)
			{
				xml.WriteElementString("chapterEnd","");
				InChapter = false;
			}
			EndLine();
			if (InDiv)
			{
				xml.WriteEndElement();	// div
				InDiv = false;
			}
			if (InPsalmTitleDiv)
			{
				xml.WriteEndElement();	// div
				InPsalmTitleDiv = false;
			}
			if (InPsalmBookDiv)
			{
				xml.WriteEndElement();	// div
				InPsalmBookDiv = false;

			}
			xml.WriteEndElement();	// text
			xml.WriteEndElement();	// book
			if (QuotationLevel > 0)
			{
				for (i = QuotationLevel - 1; i >= 0; i--)
				{
					if (i < maxQuoteLevel)
					{
						Console.WriteLine("Unmatched quote starts at {0}", QuoteStart[i]);
					}
				}
			}
			QuotationLevel = 0;
			return (s);
		}

		public int ConvertBibleFormat(string gbfname, string xsemname)
		{
			string s;
			InDiv = false;
			InPoetry = false;
			InRed = false;
			IsItalic = false;
			InVerse = false;
			InChapter = false;
			InLine = false;
			InLineGroup = false;
			InParagraph = false;
			InPsalmBookDiv = false;
			InPsalmTitleDiv = false;
			bool InContactAddress = false;
			bool InCopyrightStatement = false;
			bool InCopyrightNotice = false;
			bool InCopyrightDate = false;
			NoteNumber = 0;
			QuotationLevel = 0;
			QuoteStart = new string[maxQuoteLevel];
			ParagraphStarted = 0;

			gbf = new GBFReader(gbfname);
			Console.WriteLine("Reading {0}", gbfname);
			do
			{
				s = gbf.GetToken();
			} while (s != "<HA>" && s != "<HW>"  && s != "<HY>" && s != "<HR>" && !s.StartsWith("<B"));
			xml = new XmlTextWriter(xsemname, System.Text.Encoding.UTF8);
			xml.Formatting = Formatting.Indented;
			xml.Indentation = 1;
			xml.WriteStartDocument();
			xml.WriteDocType("scripture", null, "xsem.dtd", null);
			xml.WriteStartElement("scripture");
			xml.WriteStartElement("scriptureHeader");
			xml.WriteStartElement("translationStmt");
			xml.WriteElementString("place",gbf.sPlace);
			xml.WriteEndElement();
			xml.WriteStartElement("respStmt");
			xml.WriteStartElement("contact");
			if (gbf.sContactName != "")
				xml.WriteElementString("name", gbf.sContactName);
			else
				xml.WriteElementString("name", "unknown");
			while (s == "<HA>")
			{
				if (!InContactAddress)
				{
					xml.WriteStartElement("address");
					InContactAddress = true;
				}
				xml.WriteElementString("addressLine", gbf.GetToken());
				s = gbf.GetToken();
			}
			if (InContactAddress)
			{
				xml.WriteEndElement();	// address
				InContactAddress = false;
			}
			xml.WriteEndElement(); // contact
			xml.WriteEndElement(); // translationStmt
			
			xml.WriteStartElement("publicationStmt");
			xml.WriteStartElement("titleGroup");
			xml.WriteElementString("title", gbf.sBookTitle);
			xml.WriteElementString("subtitle", gbf.sTranslationTitle);
			xml.WriteEndElement();	// titleGroup
			xml.WriteEndElement();	// publicationStmt

			while (s == "<HW>" || s == "<HY>" || s == "<HR>" || s == "<HO>")
			{
				if (!InCopyrightStatement)
				{
					xml.WriteStartElement("copyrightStmt");
					InCopyrightStatement = true;
				}
				if (!InCopyrightNotice)
				{
					xml.WriteStartElement("copyright");
					InCopyrightNotice = true;
				}
				if (s == "<HW>")
				{
					xml.WriteElementString("work", gbf.GetToken());
					s = gbf.GetToken();
				}
				else if (s == "<HY>")
				{
					if (!InCopyrightDate)
					{
						xml.WriteStartElement("copyrightDate");
						InCopyrightDate = true;
					}
					xml.WriteElementString("year", gbf.GetToken());
					s = gbf.GetToken();
				}
				else if (s == "<HR>")
				{
					if (!InCopyrightDate)
					{
						xml.WriteStartElement("copyrightDate");
						InCopyrightDate = true;
					}
					xml.WriteStartElement("yearRange");
					s = gbf.GetToken();
					if (s.Length == 9)
					{
						xml.WriteElementString("from", s.Remove(4, s.Length - 4));
						xml.WriteElementString("to", s.Remove(0, 5));
					}
					s = gbf.GetToken();
				}
				else if (s == "<HO>")
				{
					if (InCopyrightDate)
					{
						xml.WriteEndElement(); // copyrightDate
						InCopyrightDate = false;
					}
					xml.WriteElementString("holder", gbf.GetToken());
					s = gbf.GetToken();
					if (InCopyrightNotice)
					{
						xml.WriteEndElement(); // copyrightStmt
						InCopyrightStatement = false;
					}
				}
				else if (s == "<TC>")	// Skip comment.
				{
					do
					{
						s = gbf.GetToken();
					}
					while ((s != "<Tc>") && (!gbf.Eof()));
				}
			}
			if (InCopyrightStatement)
			{
				xml.WriteEndElement();
				InCopyrightStatement = false;
			}
			if (InCopyrightDate)
			{
				xml.WriteEndElement(); // copyrightDate
				InCopyrightDate = false;
			}
			if (InCopyrightNotice)
			{
				xml.WriteEndElement(); // copyrightStmt
				InCopyrightStatement = false;
			}

			xml.WriteStartElement("langStmt");
			xml.WriteStartElement("langDecl");
			xml.WriteAttributeString("id",gbf.sLanguageEthnologueCode);
			xml.WriteString(gbf.sLanguageName);
			xml.WriteEndElement();	// langDecl
			xml.WriteEndElement();	// langStmt
			
			xml.WriteStartElement("versionStmt");
			xml.WriteStartElement("versionDecl");
			xml.WriteAttributeString("id", gbf.sTranslationAbbr);
			xml.WriteElementString("versionName", gbf.sTranslationTitle);
			xml.WriteElementString("versionAbbreviation", gbf.sTranslationAbbr);
			xml.WriteEndElement();	// versionDecl
			xml.WriteEndElement();	// versionStmt
			
			xml.WriteStartElement("bookStmt");
			while (!gbf.Eof())
			{
				// Read to next book starting point.
				while (!(s.StartsWith("<SB")) && (!gbf.Eof()))
				{
					s = gbf.GetToken();
				}
				// Read past book title to chapter one.
				while (!s.StartsWith("<SC") && (!gbf.Eof()))
				{
					s = gbf.GetToken();
				}

				if ((gbf.iBook > 0) && (gbf.iBook < 91))
				{
					Console.WriteLine("{0}: {1}", gbf.iBook, gbf.sTitle);
					xml.WriteStartElement("bookDecl");
					xml.WriteAttributeString("id", gbf.bookValue);
					xml.WriteElementString("bookAbbreviation", gbf.BookAbbr[gbf.iBook]);
					if (gbf.iBook == 19)
						xml.WriteElementString("chapterSpecifier", gbf.sPsalmSpecifier);
					else
						xml.WriteElementString("chapterSpecifier", gbf.sChapterSpecifier);
					xml.WriteElementString("verseSpecifier", gbf.sVerseSpecifier);
					xml.WriteElementString("shortName", gbf.sBook);
					xml.WriteElementString("fullName", gbf.sTitle);
					xml.WriteEndElement();	// bookDecl
				}
			}
			xml.WriteEndElement();	// bookStmt
			xml.WriteEndElement();	// ScriptureHeader

			xml.WriteStartElement("front");
			xml.WriteStartElement("div");
			Console.WriteLine("{0} ({1}) {2}", gbf.sTranslationTitle,
				gbf.sTranslationAbbr, gbf.sShortCopr);
			xml.WriteElementString("head", gbf.sTranslationTitle+" ("+
				gbf.sTranslationAbbr+")");
			xml.WriteElementString("p", gbf.sShortCopr);
			xml.WriteElementString("p", gbf.sLongCopr);
			xml.WriteEndElement();	// div
			gbf.Open(gbfname);
			do	// Skip to Introduction, New Testament, Apocrypha, or New Testament
			{
				s = gbf.GetToken();
			} while (!s.StartsWith("<B"));
			if (s == "<BI>")
			{	// Record introduction.
				Console.Write("Reading introduction.\r");
				s = gbf.GetToken();
				do
				{
					if (s == "<FB>")
					{
						xml.WriteStartElement("div");
						InDiv = true;
						xml.WriteElementString("head", gbf.GetToken());
						s = gbf.GetToken();
						if (s != "<Fb>")
						{
							Console.WriteLine("{0} line {1}: unexpected tag in preface title \"{2}\"",
								gbfname, gbf.LineNumber, s);
						}
						s = gbf.GetToken();
					}
					do
					{
						if (s[0] != '<')
						{	// Text
							if (!InParagraph)
							{
								xml.WriteStartElement("p");
								InParagraph = true;
							}
							xml.WriteString(s);
							s = gbf.GetToken();
						}
						else if ((s == "<CM>") || (s == "<CL>"))
						{
							if (InParagraph)
							{
								xml.WriteEndElement();	// p
								InParagraph = false;
							}
							s = gbf.GetToken();
						}
						else if (!s.StartsWith("<B") && !gbf.Eof())
						{
							Console.WriteLine("Unhandled tag in introduction: {0}", s);
							s = gbf.GetToken();
						}
					}
					while (((s[0] != '<') || (s == "<CM>")) && (!gbf.Eof()));
														 
					if (InParagraph)
					{
						xml.WriteEndElement();	// p
						InParagraph = false;
					}
					if (InDiv)
					{
						xml.WriteEndElement();	// div
						InDiv = false;
					}
				} while (!s.StartsWith("<B") && !gbf.Eof());

				if (InDiv)
				{
					xml.WriteEndElement();	// div
					InDiv = false;
				}
			}
			
			xml.WriteEndElement();	// front

			while (!gbf.Eof() && (s != "<ZZ>"))
			{
				switch (s)
				{
					case "<BO>":
						Console.Write("Reading Old Testament.            \r");
						xml.WriteStartElement("canon");
						xml.WriteAttributeString("id", "OT");
						xml.WriteAttributeString("value", "OT");
						xml.WriteElementString("title", "The Old Testament");
						s = gbf.GetToken();
						do
						{
							s = ReadBook(s);
						} while (s.StartsWith("<SB"));
						xml.WriteEndElement();	// canon
						break;
					case "<BA>":
						Console.Write("Reading Apocrypha.            \r");
						xml.WriteStartElement("canon");
						xml.WriteAttributeString("id", "DC");
						xml.WriteAttributeString("value","DC");
						xml.WriteElementString("title", "Apocrypha");
						s = gbf.GetToken();
						do
						{
							s = ReadBook(s);
						} while (s.StartsWith("<SB"));
						xml.WriteEndElement();	// canon
						break;
					case "<BN>":
						Console.Write("Reading New Testament.            \r");
						xml.WriteStartElement("canon");
						xml.WriteAttributeString("id", "NT");
						xml.WriteAttributeString("value", "NT");
						xml.WriteElementString("title", "The New Testament");
						s = gbf.GetToken();
						do
						{
							s = ReadBook(s);
						} while (s.StartsWith("<SB"));
						xml.WriteEndElement();	// canon
						break;
					case "<ZZ>":
						s = gbf.GetToken();
						break;
					default:
						Console.WriteLine("UNEXPECTED AT {0}: {1}", gbf.Reference(), s);
						s = gbf.GetToken();
						break;
				}
			}
			
			xml.WriteEndElement();	// scripture
			xml.WriteEndDocument();
			xml.Flush();
			xml.Close();
			Console.WriteLine("{0} written.", xsemname);
			return 0;
		}

	}

	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void help()
		{
			Console.WriteLine("Syntax:");
			Console.WriteLine("GBF2XSEM gbfname xsemname");
		}
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static int Main(string[] args)
		{
			string gbfname = "";
			string xsemname = "";

			Console.WriteLine("GBF2XSEM Copyright (C) 2002-2003 SIL International.\n"+
				"Releasable under GNU LGPL or (at your option) the Common Public License.\n");
			foreach (string arg in args)
			{
				if (gbfname == "")
					gbfname = arg;
				else if (xsemname == "")
					xsemname = arg;
				else
				{
					help();
					return 1;
				}
			}
			if (xsemname == "")
			{
				help();
				return 1;
			}
			XSEMWriter xsem = new XSEMWriter();
			return xsem.ConvertBibleFormat(gbfname, xsemname);
		}
	}
}
